%% -*- Erlang -*-
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% SSA LIVENESS ANALYSIS
%

-include("../util/hipe_vector.hrl").
-include("../flow/liveness.inc").


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Interface to CFG and icode.
%

cfg_bb(CFG, L) ->
   ?cfg:bb(CFG, L).


cfg_postorder(CFG) ->
   ?cfg:postorder(CFG).


cfg_labels(CFG) ->
   ?cfg:labels(CFG).


cfg_bb_update(CFG, L, NewBB) ->
   ?cfg:bb_update(CFG, L, NewBB).


cfg_succ_map(CFG) ->
   ?cfg:succ_map(CFG).


cfg_succ(CFG, L) ->
   ?cfg:succ(CFG, L).


uses(Instr) ->
  case ?code:type(Instr) of
    phi ->
      Def = ?code:defines(Instr),
      [X || X <- ?code:uses(Instr), not lists:member(X, Def)];
    _ ->
      ?code:uses(Instr)
  end.

defines(Instr) ->
   ?code:defines(Instr).


mk_comment(Text) ->
   ?code:mk_comment(Text).



%
% This is the list of registers that are live at exit from a function
%

liveout_no_succ() ->
    ordsets:new().
